# Generated by Django 4.2.11 on 2024-03-11 08:02

from django.db import migrations


def copy_public_system_messages_settings(apps, schema_editor):
    if not apps.is_installed("utils"):
        return

    SystemSettings = apps.get_model("core", "SystemSettings")
    PublicSystemMessages = apps.get_model("utils", "SystemMessagesSettings")

    for old_settings in PublicSystemMessages.objects.all():
        settings_kwargs = {}

        if hasattr(old_settings, "title_403"):
            settings_kwargs["title_403"] = old_settings.title_403

        if hasattr(old_settings, "body_403"):
            settings_kwargs["body_403"] = old_settings.body_403

        SystemSettings.objects.create(
            site_logo_default=old_settings.site_logo_default,
            site_logo_mobile=old_settings.site_logo_mobile,
            site_logo_link=old_settings.site_logo_link,
            nav_content=old_settings.nav_content,
            footer_content=old_settings.footer_content,
            title_404=old_settings.title_404,
            body_404=old_settings.body_404,
            **settings_kwargs,
        )


def reverse_copy_public_system_messages_settings(apps, schema_editor):
    SystemSettings = apps.get_model("core", "SystemSettings")
    SystemSettings.objects.all().delete()


class Migration(migrations.Migration):
    dependencies = [
        ("core", "0003_initial"),
    ]

    operations = [
        migrations.RunPython(
            copy_public_system_messages_settings,
            reverse_copy_public_system_messages_settings,
        ),
    ]
